<style scoped="">
.tech_analytics_ct{
  background-color: #F5F6F8;
  margin-top: 68px;
  padding-top: 33px;
  padding-bottom: 118px;
}
.tech_analytics_ct .comm_width{
  display: flex;
  justify-content: center;
}
.analytics_item_pane{
  text-align: center;
  width: 25%;
}
.analytics_item_icon{
  width: 65px;
  height: 65px;
  background-repeat: no-repeat;
  background-position: center;
  background-size: contain;
  margin: 0 auto;
  margin-top: 54px;
  margin-bottom: 54px;
}
.analytics_item_title{
  font-size: 20px;
  /*text-align: center;*/
}
.analytics_item_value{
  font-size: 36px;
  font-weight: 300;
  padding-top: 17px;
  /*text-align: center;*/
}
.total_node_num{
  background-image: url('../assets/images/主网节点数量、@2x.png');
}
.total_account_num{
  background-image: url('../assets/images/主网账户数量@2x.png');
}
.total_eosc_num{
  background-image: url('../assets/images/已发放eosc预算@2x.png');
}
.github_commit_num{
  background-image: url('../assets/images/代码提交次数@2x.png');
}
@media (max-width: 800px) {
  .tech_analytics_ct{
    margin-top: 30px;
    padding-top: 10px;
    padding-bottom: 42px;
  }
  .analytics_item_pane{
    width: 50%;
  }
  .tech_analytics_ct .comm_width{
    flex-wrap: wrap;
  }
  .analytics_item_title{
    font-size: 14px;
  }
  .analytics_item_value{
    font-size: 17px;
    padding-top: 12px;
  }
  .analytics_item_icon{
    width: 42px;
    height: 42px;
    margin-bottom: 24px;
    margin-top: 24px;
  }
}
</style>
<template>
  <div class="tech_analytics_ct">
    <div class="comm_width analytics_ct">

      <a class="analytics_item_pane" href="https://explorer.eosforce.io/#/cn/web_wallet_view" target="_blank">
        <div class="analytics_item_icon total_node_num"></div>
        <div class="analytics_item_title">{{ lang.data['Nodes'] }}</div>
        <div class="analytics_item_value">{{ bps_num }}+</div>
      </a>

      <a rel="nofollow" class="analytics_item_pane" href="https://explorer.eosforce.io" target="_blank">
        <div class="analytics_item_icon total_account_num"></div>
        <div class="analytics_item_title">{{ lang.data['Accounts'] }}</div>
        <div class="analytics_item_value">{{ split_long_num(ACCOUNT_NUM) || '...' }}+</div>
      </a>

      <a class="analytics_item_pane" href=" https://u.eosforce.io/#/" target="_blank">
        <div class="analytics_item_icon total_eosc_num"></div>
        <div class="analytics_item_title">{{ lang.data['Issued EOSC Budget'] }}</div>
        <div class="analytics_item_value">{{ split_long_num(budget_transfer_out_for_donator) || '...' }}</div>
      </a>

      <a rel="nofollow" class="analytics_item_pane" href="https://github.com/eosforce" target="_blank">
        <div class="analytics_item_icon github_commit_num"></div>
        <div class="analytics_item_title">{{ lang.data['Code Submissions'] }}</div>
        <div class="analytics_item_value">{{ code_commit_num }}</div>
      </a>

    </div>
  </div>
</template>
<script>
import { check_analytics, get_info, get_table_rows } from '../service'
import { split_long_num, wait_time } from './utils'
import { get_lang_data_by_key, set_lang } from '@/data/langs/index.js'
let lang = get_lang_data_by_key('en');

export default {
  beforeCreate () {
    lang = get_lang_data_by_key(this.$route.params.lang || 'cn');
  },
  data () {
    return {
      lang,
      ACCOUNT_NUM: '...',
      total_actived_coin: '...',
      head_block_num: 0,
      bps_num: '...',
      code_commit_num: '...',
      budget_transfer_out_for_donator: ''
    };
  },

  computed: {
    total_eosc_num_in_time () {
      if(!this.head_block_num) return '...';
      const ten_expand = 0,
            three_expand = 5822891,
            five_expand = 12767154;

      let res =  (three_expand - ten_expand) * 10 
              + (five_expand - three_expand) * 3 
              + (this.head_block_num - five_expand) * 5
              + this.total_actived_coin * 1;
      return parseInt(res);
    }
  },

  mounted () {
    this.get_info();
    this.update_from_exploer();
    this.get_bps_num();
  },

  methods: {
    async update_from_exploer () {
      while(1){
        let data = await check_analytics();
        this.ACCOUNT_NUM = data.data.find(i => i.key == 'ACCOUNT_NUM').value;
        this.total_actived_coin = data.data.find(i => i.key == 'total_actived_coin').value;
        this.code_commit_num = data.data.find(i => i.key == 'commit_hisotry').value;
        this.budget_transfer_out_for_donator = data.data.find(i => i.key == 'budget_transfer_out_for_donator').value;
        await wait_time(10);
      }
    },
    async get_info () {
      while(1){
        let info = await get_info();
        this.head_block_num = info.head_block_num;
        await wait_time(5);
      }
    },
    async get_bps_num () {
      let params = {
        "scope":"eosio",
        "code":"eosio",
        "table":"bps",
        "json":true,
        "limit":1000
      }
      while(1){
        let result = await get_table_rows(params);
        this.bps_num = result.rows.length;
        await wait_time(10);
      }
    },
    split_long_num
  }
}
</script>